﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Net;

namespace FLY.Thick.Blowing.UI.Fix.Client
{
    /// <summary>
    /// Page_ErrorTable.xaml 的交互逻辑
    /// </summary>
    public partial class Page_ErrorTable : Page
    {
        FLY.OBJComponents.Client.WarningServiceClient mWarningService;
        FLY.OBJComponents.Client.BufferWindow<FLY.OBJComponents.Common.FlyData_WarningHistory> mWindow;
        TDGage gage;

        public Page_ErrorTable()
        {
            InitializeComponent();
            Init();
        }


        public void Init()
        {
            gage = Application.Current.Properties["Gage"] as TDGage;

            mWarningService = gage.mWarningService;
            mWindow = gage.mWarningReasonWindow;
            gridFlows.ItemsSource = mWindow.Record;
        }

        private void button_back_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.GoBack();
        }



        private void button_reset_click(object sender, RoutedEventArgs e)
        {
            mWarningService.Reset();
        }

        private void button_iotip_click(object sender, RoutedEventArgs e)
        {
            Window_IOTip w = new Window_IOTip();
            w.Owner = FLY.ControlLibrary.COMMON.GetWindow(this);
            w.ShowDialog();
        }

        private void button_access_click(object sender, RoutedEventArgs e)
        {
            ThickTcpUiInWindow.Window_FlyADAccess w = new ThickTcpUiInWindow.Window_FlyADAccess();
            w.Init(gage.mSysParam.ServerIPEP);
            w.Owner = FLY.ControlLibrary.COMMON.GetWindow(this);
            w.ShowDialog();
        }
    }
}
